Index: src/sas/guiframe/gui_manager.py
===================================================================
--- src/sas/guiframe/gui_manager.py	(revision 957af0dc596ff456a7b4745fe74937a9cea56f8f)
+++ src/sas/guiframe/gui_manager.py	(revision 957af0dc596ff456a7b4745fe74937a9cea56f8f)
@@ -235,5 +235,4 @@
         Initialize the Frame object
         """
-
         PARENT_FRAME.__init__(self, parent=parent, title=title, pos=pos, size=size)
         # title
@@ -364,5 +363,5 @@
                     frame.SetIcon(icon)
                 except:
-                    pass
+                    logging.error("ViewerFrame.put_icon: could not set icon")
 
     def get_client_size(self):
@@ -752,5 +751,4 @@
             self._toolbar.Realize()
 
-
     def build_gui(self):
         """
@@ -778,5 +776,4 @@
         # Append item from plugin under menu file if necessary
         self._populate_file_menu()
-
 
         if not wx.VERSION_STRING >= '3.0.0.0':
@@ -822,5 +819,4 @@
         # Load panels
         self._load_panels()
-        self.set_default_perspective()
 
     def SetStatusText(self, *args, **kwds):
@@ -931,9 +927,5 @@
                         if hasattr(module, "PLUGIN_ID"):
                             try:
-                                plug = module.Plugin()
-                                if plug.set_default_perspective():
-                                    self._current_perspective = plug
-                                plugins.append(plug)
-
+                                plugins.append(module.Plugin())
                                 msg = "Found plug-in: %s" % module.PLUGIN_ID
                                 logging.info(msg)
@@ -1511,15 +1503,15 @@
                 for item in plugin.populate_file_menu():
                     m_name, m_hint, m_handler = item
-                    id = wx.NewId()
-                    self._file_menu.Append(id, m_name, m_hint)
-                    wx.EVT_MENU(self, id, m_handler)
+                    wx_id = wx.NewId()
+                    self._file_menu.Append(wx_id, m_name, m_hint)
+                    wx.EVT_MENU(self, wx_id, m_handler)
                 self._file_menu.AppendSeparator()
 
         style1 = self.__gui_style & GUIFRAME.MULTIPLE_APPLICATIONS
         if OPEN_SAVE_MENU:
-            id = wx.NewId()
+            wx_id = wx.NewId()
             hint_load_file = "read all analysis states saved previously"
-            self._save_appl_menu = self._file_menu.Append(id, '&Open Project', hint_load_file)
-            wx.EVT_MENU(self, id, self._on_open_state_project)
+            self._save_appl_menu = self._file_menu.Append(wx_id, '&Open Project', hint_load_file)
+            wx.EVT_MENU(self, wx_id, self._on_open_state_project)
 
         if style1 == GUIFRAME.MULTIPLE_APPLICATIONS:
@@ -1527,24 +1519,24 @@
             hint_load_file = "Read a status files and load"
             hint_load_file += " them into the analysis"
-            id = wx.NewId()
-            self._save_appl_menu = self._file_menu.Append(id,
+            wx_id = wx.NewId()
+            self._save_appl_menu = self._file_menu.Append(wx_id,
                                                           '&Open Analysis', hint_load_file)
-            wx.EVT_MENU(self, id, self._on_open_state_application)
+            wx.EVT_MENU(self, wx_id, self._on_open_state_application)
         if OPEN_SAVE_MENU:
             self._file_menu.AppendSeparator()
-            id = wx.NewId()
-            self._file_menu.Append(id, '&Save Project',
+            wx_id = wx.NewId()
+            self._file_menu.Append(wx_id, '&Save Project',
                                    'Save the state of the whole analysis')
-            wx.EVT_MENU(self, id, self._on_save_project)
+            wx.EVT_MENU(self, wx_id, self._on_save_project)
         if style1 == GUIFRAME.MULTIPLE_APPLICATIONS:
-            id = wx.NewId()
-            self._save_appl_menu = self._file_menu.Append(id, \
+            wx_id = wx.NewId()
+            self._save_appl_menu = self._file_menu.Append(wx_id, \
                 '&Save Analysis', 'Save state of the current active analysis panel')
-            wx.EVT_MENU(self, id, self._on_save_application)
+            wx.EVT_MENU(self, wx_id, self._on_save_application)
         if not sys.platform == 'darwin':
             self._file_menu.AppendSeparator()
-            id = wx.NewId()
-            self._file_menu.Append(id, '&Quit', 'Exit')
-            wx.EVT_MENU(self, id, self.Close)
+            wx_id = wx.NewId()
+            self._file_menu.Append(wx_id, '&Quit', 'Exit')
+            wx.EVT_MENU(self, wx_id, self.Close)
 
     def _add_menu_file(self):
@@ -1717,10 +1709,7 @@
         """
         """
-        message = ""
         log_msg = ''
-        output = []
-        error_message = ""
         basename = os.path.basename(path)
-        root, extension = os.path.splitext(basename)
+        _, extension = os.path.splitext(basename)
         if extension.lower() not in EXTENSIONS:
             log_msg = "File Loader cannot "
@@ -2224,16 +2213,4 @@
             if hasattr(item, "post_init"):
                 item.post_init()
-
-    def set_default_perspective(self):
-        """
-        Choose among the plugin the first plug-in that has
-        "set_default_perspective" method and its return value is True will be
-        as a default perspective when the welcome page is closed
-        """
-        for item in self.plugins:
-            if hasattr(item, "set_default_perspective"):
-                if item.set_default_perspective():
-                    item.on_perspective(event=None)
-                    return
 
     def set_perspective(self, panels):
@@ -2414,11 +2391,10 @@
             total_plot_list.append(theory_data)
         for new_plot in total_plot_list:
-            id = new_plot.id
             for group_id in new_plot.list_group_id:
-                wx.PostEvent(self, NewPlotEvent(id=id,
+                wx.PostEvent(self, NewPlotEvent(id=new_plot.id,
                                                 group_id=group_id,
                                                 action='remove'))
                 #remove res plot: Todo: improve
-                wx.CallAfter(self._remove_res_plot, id)
+                wx.CallAfter(self._remove_res_plot, new_plot.id)
         self._data_manager.delete_data(data_id=data_id,
                                        theory_id=theory_id)
@@ -2455,24 +2431,24 @@
             ext_num = dlg.GetFilterIndex()
             if ext_num == 0:
-                format = '.txt'
+                ext_format = '.txt'
             else:
-                format = '.xml'
-            path = os.path.splitext(path)[0] + format
+                ext_format = '.xml'
+            path = os.path.splitext(path)[0] + ext_format
             mypath = os.path.basename(path)
 
             #Instantiate a loader
             loader = Loader()
-            format = ".txt"
-            if os.path.splitext(mypath)[1].lower() == format:
+            ext_format = ".txt"
+            if os.path.splitext(mypath)[1].lower() == ext_format:
                 # Make sure the ext included in the file name
                 # especially on MAC
-                fName = os.path.splitext(path)[0] + format
+                fName = os.path.splitext(path)[0] + ext_format
                 self._onsaveTXT(data, fName)
-            format = ".xml"
-            if os.path.splitext(mypath)[1].lower() == format:
+            ext_format = ".xml"
+            if os.path.splitext(mypath)[1].lower() == ext_format:
                 # Make sure the ext included in the file name
                 # especially on MAC
-                fName = os.path.splitext(path)[0] + format
-                loader.save(fName, data, format)
+                fName = os.path.splitext(path)[0] + ext_format
+                loader.save(fName, data, ext_format)
             try:
                 self._default_save_location = os.path.dirname(path)
@@ -2598,8 +2574,8 @@
             ext_num = dlg.GetFilterIndex()
             if ext_num == 0:
-                format = '.dat'
+                ext_format = '.dat'
             else:
-                format = ''
-            path = os.path.splitext(path)[0] + format
+                ext_format = ''
+            path = os.path.splitext(path)[0] + ext_format
             mypath = os.path.basename(path)
 
@@ -2607,10 +2583,10 @@
             loader = Loader()
 
-            format = ".dat"
-            if os.path.splitext(mypath)[1].lower() == format:
+            ext_format = ".dat"
+            if os.path.splitext(mypath)[1].lower() == ext_format:
                 # Make sure the ext included in the file name
                 # especially on MAC
-                fileName = os.path.splitext(path)[0] + format
-                loader.save(fileName, data, format)
+                fileName = os.path.splitext(path)[0] + ext_format
+                loader.save(fileName, data, ext_format)
             try:
                 self._default_save_location = os.path.dirname(path)
@@ -3206,7 +3182,7 @@
 
 
-class ViewApp(wx.App):
+class SasViewApp(wx.App):
     """
-    Toy application to test this Frame
+    SasView application
     """
     def OnInit(self):
@@ -3294,6 +3270,6 @@
             if len(os.listdir(model_folder)) > 0:
                 try:
-                    for file in os.listdir(model_folder):
-                        file_path = os.path.join(model_folder, file)
+                    for filename in os.listdir(model_folder):
+                        file_path = os.path.join(model_folder, filename)
                         if os.path.isfile(file_path):
                             os.remove(file_path)
@@ -3314,8 +3290,5 @@
         """
         #try to load file at the start
-        try:
-            self.open_file()
-        except:
-            raise
+        self.open_file()
         self.frame.build_gui()
 
Index: src/sas/guiframe/local_perspectives/data_loader/data_loader.py
===================================================================
--- src/sas/guiframe/local_perspectives/data_loader/data_loader.py	(revision f76bf175a3375937e71ee279db24101709d87f13)
+++ src/sas/guiframe/local_perspectives/data_loader/data_loader.py	(revision f21d4969d416d232125ec9af18b6bb0189f68ace)
@@ -41,6 +41,6 @@
 class Plugin(PluginBase):
 
-    def __init__(self, standalone=False):
-        PluginBase.__init__(self, name="DataLoader", standalone=standalone)
+    def __init__(self):
+        PluginBase.__init__(self, name="DataLoader")
         # Default location
         self._default_save_location = DEFAULT_OPEN_FOLDER
Index: src/sas/guiframe/local_perspectives/plotting/plotting.py
===================================================================
--- src/sas/guiframe/local_perspectives/plotting/plotting.py	(revision c039589ad31dec3058311cae229f7aa1dc56faf8)
+++ src/sas/guiframe/local_perspectives/plotting/plotting.py	(revision f21d4969d416d232125ec9af18b6bb0189f68ace)
@@ -36,6 +36,6 @@
     """
 
-    def __init__(self, standalone=False):
-        PluginBase.__init__(self, name="Plotting", standalone=standalone)
+    def __init__(self):
+        PluginBase.__init__(self, name="Plotting")
 
         ## Plot panels
Index: src/sas/guiframe/plugin_base.py
===================================================================
--- src/sas/guiframe/plugin_base.py	(revision 373d4eebe3a548f70f917fec87bdb5280e67d1e0)
+++ src/sas/guiframe/plugin_base.py	(revision f21d4969d416d232125ec9af18b6bb0189f68ace)
@@ -34,5 +34,5 @@
     """
 
-    def __init__(self, name="Test_plugin", standalone=True):
+    def __init__(self, name="Test_plugin"):
         """
         Abstract class for gui_manager Plugins.
@@ -42,6 +42,4 @@
         ## Plug-in name. It will appear on the application menu.
         self.sub_menu = name
-        #standalone flag
-        self.standalone = standalone
         ## Reference to the parent window. Filled by get_panels() below.
         self.parent = None
@@ -263,15 +261,4 @@
         pass
 
-    def set_default_perspective(self):
-        """
-       Call back method that True to notify the parent that the current plug-in
-       can be set as default  perspective.
-       when returning False, the plug-in is not candidate for an automatic
-       default perspective setting
-        """
-        if self.standalone:
-            return True
-        return False
-
     def set_state(self, state=None, datainfo=None):    
         """
Index: src/sas/perspectives/calculator/calculator.py
===================================================================
--- src/sas/perspectives/calculator/calculator.py	(revision 49ab5d718dd7743a6a296e666dfb643183bc969d)
+++ src/sas/perspectives/calculator/calculator.py	(revision f21d4969d416d232125ec9af18b6bb0189f68ace)
@@ -33,6 +33,6 @@
     for calculator perspective
     """
-    def __init__(self, standalone=True):
-        PluginBase.__init__(self, name="Calculator", standalone=standalone)
+    def __init__(self):
+        PluginBase.__init__(self, name="Calculator")
         # Log startup
         logging.info("Calculator plug-in started")
Index: src/sas/perspectives/fitting/fitpage.py
===================================================================
--- src/sas/perspectives/fitting/fitpage.py	(revision 098f3d277d54e6ae4bae35ed0188be84b67fb171)
+++ src/sas/perspectives/fitting/fitpage.py	(revision 098f3d277d54e6ae4bae35ed0188be84b67fb171)
@@ -268,6 +268,4 @@
         weighting_box.Add(sizer_weighting)
 
-        sizer_fit = wx.GridSizer(2, 5, 2, 6)
-
         # combobox for smear2d accuracy selection
         self.smear_accuracy = wx.ComboBox(self, -1, size=(50, -1),
@@ -282,5 +280,5 @@
 
         #Fit button
-        self.btFit = wx.Button(self, wx.NewId(), 'Fit', size=(88, 25))
+        self.btFit = wx.Button(self, wx.NewId(), 'Fit')
         self.default_bt_colour = self.btFit.GetDefaultAttributes()
         self.btFit.Bind(wx.EVT_BUTTON, self._onFit, id=self.btFit.GetId())
@@ -288,6 +286,6 @@
 
         #General Help button
-        self.btFitHelp = wx.Button(self, -1, 'HELP')
-        self.btFitHelp.SetToolTipString("General Fitting Help.")
+        self.btFitHelp = wx.Button(self, -1, 'Help')
+        self.btFitHelp.SetToolTipString("General fitting help.")
         self.btFitHelp.Bind(wx.EVT_BUTTON, self._onFitHelp)
         
@@ -303,5 +301,5 @@
         self.btSmearHelp = wx.Button(self, -1, '?', style=wx.BU_EXACTFIT,\
                                      size=size_q)
-        self.btSmearHelp.SetToolTipString("Resolution Smearing Help.")
+        self.btSmearHelp.SetToolTipString("Resolution smearing help.")
         self.btSmearHelp.Bind(wx.EVT_BUTTON, self._onSmearHelp)
         
@@ -362,21 +360,8 @@
         self.disable_smearer.SetValue(True)
 
-        # add 4 types of smearing to the sizer
-        # Note from June 14, 2015
-        # removed the extra (10,10) spaces to make room for help.  Actually
-        # don't see the need for those anyway as the wx.LEFT, xx should take
-        # care of spacing anyway though it does not seem to work for some
-        # reason.  Currently leaving as we are in "code freeze" only making
-        # minimal changes necessary for release 3.1.  We probably want to clean
-        # up the whole fitpage (and basepage and fitpanel etc) eventually.
-        #                          ---- PDB
         sizer_smearer.Add(self.disable_smearer, 0, wx.LEFT, 10)
-#        sizer_smearer.Add((10, 10))
         sizer_smearer.Add(self.enable_smearer)
-#        sizer_smearer.Add((10, 10))
         sizer_smearer.Add(self.pinhole_smearer)
-#        sizer_smearer.Add((10, 10))
         sizer_smearer.Add(self.slit_smearer)
-#        sizer_smearer.Add((10, 10))
         sizer_smearer.Add(self.btSmearHelp)
         sizer_smearer.Add((10, 10))
@@ -397,6 +382,5 @@
 
         # Update and Draw button
-        self.draw_button = wx.Button(self, wx.NewId(),
-                                     'Compute', size=(88, 24))
+        self.draw_button = wx.Button(self, wx.NewId(), 'Compute')
         self.draw_button.Bind(wx.EVT_BUTTON, \
                               self._onDraw, id=self.draw_button.GetId())
@@ -414,19 +398,4 @@
         box_description_1 = wx.StaticText(self, -1, '   Chi2/Npts')
         box_description_2 = wx.StaticText(self, -1, 'Npts(Fit)')
-        #box_description_3 = wx.StaticText(self, -1, 'Total Npts')
-        #box_description_3.SetToolTipString( \
-        #                        " Total Npts : total number of data points")
-
-        sizer_fit.Add(box_description_1, 0, 0)
-        sizer_fit.Add(box_description_2, 0, 0)
-        sizer_fit.Add(self.points_sizer, 0, 0)
-        #sizer_fit.Add(box_description_3, 0, 0)
-        sizer_fit.Add(self.draw_button, 0, 0)
-        sizer_fit.Add((-1,5))
-        sizer_fit.Add(self.tcChi, 0, 0)
-        sizer_fit.Add(self.Npts_fit, 0, 0)
-        sizer_fit.Add(self.Npts_total, 0, 0)
-        sizer_fit.Add(self.btFit, 0, 0)
-        sizer_fit.Add(self.btFitHelp, 0, 0)
 
         # StaticText for smear
@@ -576,13 +545,13 @@
         self.qmin.Bind(wx.EVT_TEXT, self.on_qrange_text)
         self.qmax.Bind(wx.EVT_TEXT, self.on_qrange_text)
-        id = wx.NewId()
-        self.reset_qrange = wx.Button(self, id, 'Reset', size=(77, 20))
-
-        self.reset_qrange.Bind(wx.EVT_BUTTON, self.on_reset_clicked, id=id)
+        wx_id = wx.NewId()
+        self.reset_qrange = wx.Button(self, wx_id, 'Reset')
+
+        self.reset_qrange.Bind(wx.EVT_BUTTON, self.on_reset_clicked, id=wx_id)
         self.reset_qrange.SetToolTipString("Reset Q range to the default")
 
-        sizer = wx.GridSizer(2, 4, 2, 6)
-
-        self.btEditMask = wx.Button(self, wx.NewId(), 'Editor', size=(88, 23))
+        sizer = wx.GridSizer(5, 5, 2, 6)
+
+        self.btEditMask = wx.Button(self, wx.NewId(), 'Editor')
         self.btEditMask.Bind(wx.EVT_BUTTON, self._onMask,
                              id=self.btEditMask.GetId())
@@ -594,15 +563,28 @@
         sizer.Add(wx.StaticText(self, -1, ' Max[1/A]'))
         sizer.Add(self.EditMask_title)
+        sizer.Add((-1,5))
+
         sizer.Add(self.reset_qrange)
         sizer.Add(self.qmin)
         sizer.Add(self.qmax)
-        #sizer.Add(self.theory_npts_tcrtl)
         sizer.Add(self.btEditMask)
+        sizer.Add((-1,5))
+
+        sizer.AddMany(5*[(-1,5)])
+
+        sizer.Add(box_description_1, 0, 0)
+        sizer.Add(box_description_2, 0, 0)
+        sizer.Add(self.points_sizer, 0, 0)
+        sizer.Add(self.draw_button, 0, 0)
+        sizer.Add((-1,5))
+        
+        sizer.Add(self.tcChi, 0, 0)
+        sizer.Add(self.Npts_fit, 0, 0)
+        sizer.Add(self.Npts_total, 0, 0)
+        sizer.Add(self.btFit, 0, 0)
+        sizer.Add(self.btFitHelp, 0, 0)
+        
         boxsizer_range.Add(sizer_chi2)
-        boxsizer_range.Add((10, 10))
         boxsizer_range.Add(sizer)
-
-        boxsizer_range.Add((10, 15))
-        boxsizer_range.Add(sizer_fit)
         if is_2Ddata:
             self.btEditMask.Enable()
Index: src/sas/perspectives/fitting/fitting.py
===================================================================
--- src/sas/perspectives/fitting/fitting.py	(revision 098f3d277d54e6ae4bae35ed0188be84b67fb171)
+++ src/sas/perspectives/fitting/fitting.py	(revision 098f3d277d54e6ae4bae35ed0188be84b67fb171)
@@ -61,6 +61,6 @@
     Fitting plugin is used to perform fit
     """
-    def __init__(self, standalone=False):
-        PluginBase.__init__(self, name="Fitting", standalone=standalone)
+    def __init__(self):
+        PluginBase.__init__(self, name="Fitting")
 
         #list of panel to send to guiframe
@@ -221,6 +221,6 @@
         Get the python editor panel
         """
-        id = event.GetId()
-        label = self.edit_menu.GetLabel(id)
+        event_id = event.GetId()
+        label = self.edit_menu.GetLabel(event_id)
         from sas.perspectives.calculator.pyconsole import PyConsole
         filename = os.path.join(models.find_plugins_dir(), label)
@@ -236,6 +236,6 @@
         Delete custom model file
         """
-        id = event.GetId()
-        label = self.delete_menu.GetLabel(id)
+        event_id = event.GetId()
+        label = self.delete_menu.GetLabel(event_id)
         toks = os.path.splitext(label)
         path = os.path.join(models.find_plugins_dir(), toks[0])
@@ -256,5 +256,5 @@
                 #                                      info='warning'))
             else:
-                self.delete_menu.Delete(id)
+                self.delete_menu.Delete(event_id)
                 for item in self.edit_menu.GetMenuItems():
                     if item.GetLabel() == label:
@@ -272,5 +272,5 @@
         Edit summodel template and make one
         """
-        id = event.GetId()
+        event_id = event.GetId()
         model_manager = models.ModelManager()
         model_list = model_manager.get_model_name_list()
@@ -290,5 +290,5 @@
             self.new_model_frame.Show(True)
         else:
-            id = event.GetId()
+            event_id = event.GetId()
             dir_path = models.find_plugins_dir()
             title = "New Custom Model Function"
@@ -332,13 +332,13 @@
         Set list of the edit model menu labels
         """
-        id = wx.NewId()
+        wx_id = wx.NewId()
         #new_model_menu = wx.Menu()
-        self.edit_model_menu.Append(id, 'New',
+        self.edit_model_menu.Append(wx_id, 'New',
                                    'Add a new model function')
-        wx.EVT_MENU(owner, id, self.make_new_model)
-        id = wx.NewId()
-        self.edit_model_menu.Append(id, 'Sum|Multi(p1, p2)',
+        wx.EVT_MENU(owner, wx_id, self.make_new_model)
+        wx_id = wx.NewId()
+        self.edit_model_menu.Append(wx_id, 'Sum|Multi(p1, p2)',
                                     'Sum of two model functions')
-        wx.EVT_MENU(owner, id, self.make_sum_model)
+        wx.EVT_MENU(owner, wx_id, self.make_sum_model)
         e_id = wx.NewId()
         self.edit_menu = wx.Menu()
@@ -376,7 +376,7 @@
                         has_file = True
                 if not has_file:
-                    id = wx.NewId()
-                    submenu.Append(id, name)
-                    wx.EVT_MENU(owner, id, menu)
+                    wx_id = wx.NewId()
+                    submenu.Append(wx_id, name)
+                    wx.EVT_MENU(owner, wx_id, menu)
                     has_file = False
 
@@ -397,8 +397,8 @@
         Create a page to access simultaneous fit option
         """
-        id = event.GetId()
+        event_id = event.GetId()
         caption = "Const & Simul Fit"
         page = self.sim_page
-        if id == self.id_batchfit:
+        if event_id == self.id_batchfit:
             caption = "Combined Batch"
             page = self.batch_page
@@ -719,6 +719,6 @@
         for uid, value in self.page_finder.iteritems():
             if uid != sim_page_id and uid != self.batch_page.uid:
-                list = value.get_model()
-                model = list[0]
+                model_list = value.get_model()
+                model = model_list[0]
                 if model.name == modelname:
                     value.set_model_param(names, values)
@@ -1568,5 +1568,4 @@
         """
         if event.panel is not None:
-            new_panel = event.panel
             self.slicer_panels.append(event.panel)
             # Set group ID if available
@@ -1652,5 +1651,5 @@
             #find if this theory was already plotted and replace that plot given
             #the same id
-            theory_data = self.page_finder[page_id].get_theory_data(fid=data.id)
+            self.page_finder[page_id].get_theory_data(fid=data.id)
 
             if data.is_data:
Index: src/sas/perspectives/invariant/invariant.py
===================================================================
--- src/sas/perspectives/invariant/invariant.py	(revision 824e488a9a9f8e5e5eaf22c06f7c7d7a0c3af455)
+++ src/sas/perspectives/invariant/invariant.py	(revision f21d4969d416d232125ec9af18b6bb0189f68ace)
@@ -33,6 +33,6 @@
     """
 
-    def __init__(self, standalone=False):
-        PluginBase.__init__(self, name="Invariant", standalone=standalone)
+    def __init__(self):
+        PluginBase.__init__(self, name="Invariant")
 
         # dictionary containing data name and error on dy of that data
Index: src/sas/perspectives/pr/inversion_panel.py
===================================================================
--- src/sas/perspectives/pr/inversion_panel.py	(revision 3db44fbfe87ababed011758181e38e2806c5aac2)
+++ src/sas/perspectives/pr/inversion_panel.py	(revision f21d4969d416d232125ec9af18b6bb0189f68ace)
@@ -35,5 +35,5 @@
     oscillation_max = 1.5
 
-    def __init__(self, parent, id=-1, plots=None, standalone=False, **kwargs):
+    def __init__(self, parent, id=-1, plots=None, **kwargs):
         """
         """
@@ -83,6 +83,4 @@
         ## Data manager
         self._manager = None
-        ## Standalone flage
-        self.standalone = standalone
         ## Default file location for save
         self._default_save_location = os.getcwd()
Index: src/sas/perspectives/pr/pr.py
===================================================================
--- src/sas/perspectives/pr/pr.py	(revision c1c14ba9b3ae5bcab67dc3062cd6beeb8fd130dc)
+++ src/sas/perspectives/pr/pr.py	(revision f21d4969d416d232125ec9af18b6bb0189f68ace)
@@ -54,6 +54,6 @@
     DEFAULT_DMAX = 140.0
 
-    def __init__(self, standalone=True):
-        PluginBase.__init__(self, name="Pr Inversion", standalone=standalone)
+    def __init__(self):
+        PluginBase.__init__(self, name="Pr Inversion")
         ## Simulation window manager
         self.simview = None
@@ -94,6 +94,4 @@
         ## Number of P(r) points to display on the output plot
         self._pr_npts = 51
-        ## Flag to let the plug-in know that it is running standalone
-        self.standalone = standalone
         self._normalize_output = False
         self._scale_output_unity = False
@@ -623,5 +621,5 @@
             return []
         elif item.id == graph.selected_plottable:
-            if not self.standalone and issubclass(item.__class__, Data1D):
+            if issubclass(item.__class__, Data1D):
                 return [["Compute P(r)",
                          "Compute P(r) from distribution",
@@ -1238,6 +1236,5 @@
         self.frame = MDIFrame(self.parent, None, 'None', (100, 200))
         self.control_panel = InversionControl(self.frame, -1,
-                                              style=wx.RAISED_BORDER,
-                                              standalone=self.standalone)
+                                              style=wx.RAISED_BORDER)
         self.frame.set_panel(self.control_panel)
         self._frame_set_helper()
@@ -1317,4 +1314,3 @@
             [Somehow openGL needs this call]
         """
-        if self.standalone:
-            self.parent.set_perspective(self.perspective)
+        pass