Index: src/sas/sasgui/perspectives/calculator/calculator.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/calculator.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/calculator/calculator.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -93,5 +93,5 @@
         Edit meta data
         """
-        if self.data_edit_frame == None:
+        if self.data_edit_frame is None:
             self.data_edit_frame = DataEditorWindow(parent=self.parent,
                                                     manager=self, data=[],
@@ -106,5 +106,5 @@
         Data operation
         """
-        if self.data_operator_frame == None:
+        if self.data_operator_frame is None:
             # Use one frame all the time
             self.data_operator_frame = DataOperatorWindow(parent=self.parent,
@@ -121,5 +121,5 @@
         Compute the Kiessig thickness
         """
-        if self.kiessig_frame == None:
+        if self.kiessig_frame is None:
             frame = KiessigWindow(parent=self.parent, manager=self)
             self.put_icon(frame)
@@ -133,5 +133,5 @@
         Compute the scattering length density of molecula
         """
-        if self.sld_frame == None:
+        if self.sld_frame is None:
             frame = SldWindow(parent=self.parent,
                                   base=self.parent, manager=self)
@@ -146,5 +146,5 @@
         Compute the mass density or molar voulme
         """
-        if self.cal_md_frame == None:
+        if self.cal_md_frame is None:
             frame = DensityWindow(parent=self.parent,
                                   base=self.parent, manager=self)
@@ -159,5 +159,5 @@
         Compute the slit size a given data
         """
-        if self.cal_slit_frame == None:
+        if self.cal_slit_frame is None:
             frame = SlitLengthCalculatorWindow(parent=self.parent, manager=self)
             self.put_icon(frame)
@@ -171,5 +171,5 @@
         Estimate the instrumental resolution
         """
-        if self.cal_res_frame == None:
+        if self.cal_res_frame is None:
             frame = ResolutionWindow(parent=self.parent, manager=self)
             self.put_icon(frame)
@@ -183,5 +183,5 @@
         On Generic model menu event
         """
-        if self.gen_frame == None:
+        if self.gen_frame is None:
             frame = SasGenWindow(parent=self.parent, manager=self)
             self.put_icon(frame)
@@ -214,5 +214,5 @@
         :param filename: file name to open in editor
         """
-        if self.py_frame == None:
+        if self.py_frame is None:
             frame = PyConsole(parent=self.parent, base=self,
                               filename=filename)
Index: src/sas/sasgui/perspectives/calculator/data_editor.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/data_editor.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/calculator/data_editor.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -419,5 +419,5 @@
         """
         path = None
-        if location == None:
+        if location is None:
             location = os.getcwd()
 
Index: src/sas/sasgui/perspectives/calculator/data_operator.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/data_operator.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/calculator/data_operator.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -198,5 +198,5 @@
         self.send_warnings('')
         msg = ''
-        if name == None:
+        if name is None:
             text = self.data_namectr.GetValue().strip()
         else:
@@ -205,5 +205,5 @@
         name_list = []
         for state in state_list:
-            if state.data == None:
+            if state.data is None:
                 theory_list = state.get_theory()
                 theory, _ = theory_list.values()[0]
@@ -278,5 +278,5 @@
         pos = item.GetCurrentSelection()
         data = item.GetClientData(pos)
-        if data == None:
+        if data is None:
             content = "?"
             self.put_text_pic(self.data1_pic, content)
@@ -313,5 +313,5 @@
         content = "?"
         if not (self.numberctr.IsShown() and self.numberctr.IsEnabled()):
-            if data == None:
+            if data is None:
                 content = "?"
                 self.put_text_pic(self.data2_pic, content)
@@ -355,5 +355,5 @@
         pos1 = self.data1_cbox.GetCurrentSelection()
         data1 = self.data1_cbox.GetClientData(pos1)
-        if data1 == None:
+        if data1 is None:
             self.output = None
             return flag
@@ -361,5 +361,5 @@
         data2 = self.data2_cbox.GetClientData(pos2)
 
-        if data2 == None:
+        if data2 is None:
             self.output = None
             return flag
@@ -422,5 +422,5 @@
         """
         out = self.out_pic
-        if output == None:
+        if output is None:
             content = "?"
             self.put_text_pic(out, content)
@@ -592,5 +592,5 @@
         name_list = []
         for state in state_list:
-            if state.data == None:
+            if state.data is None:
                 theory_list = state.get_theory()
                 theory, _ = theory_list.values()[0]
@@ -609,5 +609,5 @@
             wx.MessageBox(msg, 'Error')
             return
-        if self.output == None:
+        if self.output is None:
             msg = "No Output Data has been generated...   "
             wx.MessageBox(msg, 'Error')
Index: src/sas/sasgui/perspectives/calculator/density_panel.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/density_panel.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/calculator/density_panel.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -239,5 +239,5 @@
         update units and output combobox
         """
-        if event == None:
+        if event is None:
             return
         event.Skip()
@@ -257,5 +257,5 @@
         update units and input combobox
         """
-        if event == None:
+        if event is None:
             return
         event.Skip()
Index: src/sas/sasgui/perspectives/calculator/gen_scatter_panel.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/gen_scatter_panel.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/calculator/gen_scatter_panel.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -487,5 +487,5 @@
         path = None
         filename = ''
-        if location == None:
+        if location is None:
             location = os.getcwd()
 
@@ -864,5 +864,5 @@
             return
         self.sld_data = self.parent.get_sld_from_omf()
-        if self.sld_data == None:
+        if self.sld_data is None:
             if self.parent.parent != None:
                 infor = 'Error'
@@ -880,5 +880,5 @@
             self.model.set_sld_data(self.sld_data)
             self.set_input_params()
-            if self.is_avg or self.is_avg == None:
+            if self.is_avg or self.is_avg is None:
                 self._create_default_1d_data()
                 i_out = np.zeros(len(self.data.y))
@@ -979,5 +979,5 @@
         Update the progress bar
         """
-        if self.parent.parent == None:
+        if self.parent.parent is None:
             return
         type = "progress"
@@ -1010,5 +1010,5 @@
                 out = np.append(out, outi)
         #print time.time() - s
-        if self.is_avg or self.is_avg == None:
+        if self.is_avg or self.is_avg is None:
             self._draw1D(out)
         else:
@@ -1287,13 +1287,13 @@
             key_low = key.lower()
             if key_low.count('mx') > 0:
-                if sld_sets[key] == None:
+                if sld_sets[key] is None:
                     sld_sets[key] = self.sld_data.sld_mx
                 mx = sld_sets[key]
             elif key_low.count('my') > 0:
-                if sld_sets[key] == None:
+                if sld_sets[key] is None:
                     sld_sets[key] = self.sld_data.sld_my
                 my = sld_sets[key]
             elif key_low.count('mz') > 0:
-                if sld_sets[key] == None:
+                if sld_sets[key] is None:
                     sld_sets[key] = self.sld_data.sld_mz
                 mz = sld_sets[key]
@@ -1368,5 +1368,5 @@
         """
 
-        if omfdata == None:
+        if omfdata is None:
             self._set_none_text()
             return
@@ -1437,5 +1437,5 @@
         self.slds = []
         omfdata = self.sld_data
-        if omfdata == None:
+        if omfdata is None:
             raise
         sld_key_list = self._get_slds_key_list(omfdata)
@@ -1477,5 +1477,5 @@
         self.nodes = []
         omfdata = self.sld_data
-        if omfdata == None:
+        if omfdata is None:
             raise
         key_list = self._get_nodes_key_list(omfdata)
@@ -1512,5 +1512,5 @@
         self.stepsize = []
         omfdata = self.sld_data
-        if omfdata == None:
+        if omfdata is None:
             raise
         key_list = self._get_step_key_list(omfdata)
@@ -1631,5 +1631,5 @@
         Set sld textctrls
         """
-        if sld_data == None:
+        if sld_data is None:
             for ctr_list in self.slds:
                 ctr_list[1].Enable(False)
@@ -1739,5 +1739,5 @@
             if npts > 0:
                 nop = self.set_npts_from_slddata()
-                if nop == None:
+                if nop is None:
                     nop = npts
                 self.display_npts(nop)
@@ -1911,8 +1911,8 @@
         Set omfdata
         """
-        if data == None:
+        if data is None:
             return
         self.sld_data = data
-        enable = (not data == None)
+        enable = (not data is None)
         self._set_omfpanel_sld_data(self.sld_data)
         self.omfpanel.bt_save.Enable(enable)
Index: src/sas/sasgui/perspectives/calculator/image_viewer.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/image_viewer.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/calculator/image_viewer.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -85,5 +85,5 @@
         """
         path = None
-        if location == None:
+        if location is None:
             location = os.getcwd()
         dlg = wx.FileDialog(self.parent, "Image Viewer: Choose a image file",
Index: src/sas/sasgui/perspectives/calculator/model_editor.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/model_editor.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/calculator/model_editor.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -1388,5 +1388,5 @@
 
     def _get_upper_name(self, name=None):
-        if name == None:
+        if name is None:
             return ""
         upper_name = ""
Index: src/sas/sasgui/perspectives/calculator/resolution_calculator_panel.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/resolution_calculator_panel.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/calculator/resolution_calculator_panel.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -839,5 +839,5 @@
         : Param image: pylab object
         """
-        if image == None:
+        if image is None:
             return
         if color == 'g':
@@ -973,5 +973,5 @@
         if len(qx) != len(qy):
             return None
-        if qx == None or qy == None:
+        if qx is None or qy is None:
             return None
         return qx, qy
@@ -1261,5 +1261,5 @@
         if selection == 'Add new':
             path = self._selectDlg()
-            if path == None:
+            if path is None:
                 self.spectrum_cb.SetValue('Flat')
                 self.resolution.set_spectrum(self.spectrum_dic['Flat'])
@@ -1301,5 +1301,5 @@
         """
         try:
-            if path == None:
+            if path is None:
                 wx.PostEvent(self.parent.parent, StatusEvent(status=\
                             " Selected Distribution was not loaded: %s" % path))
Index: src/sas/sasgui/perspectives/calculator/slit_length_calculator_panel.py
===================================================================
--- src/sas/sasgui/perspectives/calculator/slit_length_calculator_panel.py	(revision d0248bd59e16e863c884f4be9af0a03b2a86b6e2)
+++ src/sas/sasgui/perspectives/calculator/slit_length_calculator_panel.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -157,5 +157,5 @@
         path = None
         filename = ''
-        if location == None:
+        if location is None:
             location = os.getcwd()
 
Index: src/sas/sasgui/perspectives/corfunc/corfunc_state.py
===================================================================
--- src/sas/sasgui/perspectives/corfunc/corfunc_state.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/perspectives/corfunc/corfunc_state.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -327,5 +327,5 @@
         if datainfo.title is None or datainfo.title == '':
             datainfo.title = datainfo.name
-        if datainfo.run_name == None or datainfo.run_name == '':
+        if datainfo.run_name is None or datainfo.run_name == '':
             datainfo.run = [str(datainfo.name)]
             datainfo.run_name[0] = datainfo.name
Index: src/sas/sasgui/perspectives/fitting/fitting.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitting.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/perspectives/fitting/fitting.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -386,5 +386,5 @@
         help for setting list of the edit model menu labels
         """
-        if menu == None:
+        if menu is None:
             menu = self.edit_custom_model
         list_fnames = os.listdir(models.find_plugins_dir())
@@ -1125,5 +1125,5 @@
         page = self.fit_panel.set_data(data)
         # page could be None when loading state files
-        if page == None:
+        if page is None:
             return page
         #append Data1D to the panel containing its theory
@@ -1193,5 +1193,5 @@
         """
         # case that uid is not specified
-        if uid == None:
+        if uid is None:
             for page_id in self.page_finder.keys():
                 self.page_finder[page_id].schedule_tofit(value)
@@ -1231,5 +1231,5 @@
         """
         panel = self.plot_panel
-        if panel == None:
+        if panel is None:
             raise ValueError, "Fitting:_onSelect: NonType panel"
         Plugin.on_perspective(self, event=event)
@@ -1335,5 +1335,5 @@
                 if not correct_result or res.fitness is None or \
                     not np.isfinite(res.fitness) or \
-                        np.any(res.pvec == None) or not \
+                        np.any(res.pvec is None) or not \
                         np.all(np.isfinite(res.pvec)):
                     data_name = str(None)
@@ -1526,5 +1526,5 @@
                 if res.fitness is None or \
                     not np.isfinite(res.fitness) or \
-                        np.any(res.pvec == None) or \
+                        np.any(res.pvec is None) or \
                     not np.all(np.isfinite(res.pvec)):
                     fit_msg += "\nFitting did not converge!!!"
@@ -1587,5 +1587,5 @@
         """
         event.Skip()
-        if self.menu1 == None:
+        if self.menu1 is None:
             return
         menu_item = self.menu1.FindItemById(self.id_reset_flag)
@@ -1646,5 +1646,5 @@
         caption = evt.caption
         enable_smearer = evt.enable_smearer
-        if model == None:
+        if model is None:
             return
         if uid not in self.page_finder.keys():
@@ -1698,5 +1698,5 @@
         new_plot.title = data.name
         new_plot.group_id = data.group_id
-        if new_plot.group_id == None:
+        if new_plot.group_id is None:
             new_plot.group_id = data.group_id
         new_plot.id = data_id
@@ -2002,11 +2002,11 @@
         chisqr = None
         #to compute chisq make sure data has valid data
-        # return None if data == None
-        if not check_data_validity(data_copy) or data_copy == None:
+        # return None if data is None
+        if not check_data_validity(data_copy) or data_copy is None:
             return chisqr
 
         # Get data: data I, theory I, and data dI in order
         if data_copy.__class__.__name__ == "Data2D":
-            if index == None:
+            if index is None:
                 index = np.ones(len(data_copy.data), dtype=bool)
             if weight != None:
@@ -2017,5 +2017,5 @@
             fn = data_copy.data[index]
             theory_data = self.page_finder[page_id].get_theory_data(fid=data_copy.id)
-            if theory_data == None:
+            if theory_data is None:
                 return chisqr
             gn = theory_data.data[index]
@@ -2023,9 +2023,9 @@
         else:
             # 1 d theory from model_thread is only in the range of index
-            if index == None:
+            if index is None:
                 index = np.ones(len(data_copy.y), dtype=bool)
             if weight != None:
                 data_copy.dy = weight
-            if data_copy.dy == None or data_copy.dy == []:
+            if data_copy.dy is None or data_copy.dy == []:
                 dy = np.ones(len(data_copy.y))
             else:
@@ -2037,5 +2037,5 @@
 
             theory_data = self.page_finder[page_id].get_theory_data(fid=data_copy.id)
-            if theory_data == None:
+            if theory_data is None:
                 return chisqr
             gn = theory_data.y
@@ -2080,5 +2080,5 @@
             theory_data = self.page_finder[page_id].get_theory_data(fid=data_copy.id)
             gn = theory_data.data
-            if weight == None:
+            if weight is None:
                 en = data_copy.err_data
             else:
@@ -2101,8 +2101,8 @@
         else:
             # 1 d theory from model_thread is only in the range of index
-            if data_copy.dy == None or data_copy.dy == []:
+            if data_copy.dy is None or data_copy.dy == []:
                 dy = np.ones(len(data_copy.y))
             else:
-                if weight == None:
+                if weight is None:
                     dy = np.ones(len(data_copy.y))
                 ## Set consitently w/AbstractFitengine:
@@ -2142,5 +2142,5 @@
         ##group_id specify on which panel to plot this data
         group_id = self.page_finder[page_id].get_graph_id()
-        if group_id == None:
+        if group_id is None:
             group_id = data.group_id
         new_plot.group_id = "res" + str(group_id)
Index: src/sas/sasgui/perspectives/fitting/model_thread.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/model_thread.py	(revision 9a5097cd1c76689d1f997b85ba43d12a95d8f243)
+++ src/sas/sasgui/perspectives/fitting/model_thread.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -53,7 +53,7 @@
         self.starttime = time.time()
         # Determine appropriate q range
-        if self.qmin == None:
+        if self.qmin is None:
             self.qmin = 0
-        if self.qmax == None:
+        if self.qmax is None:
             if self.data != None:
                 newx = math.pow(max(math.fabs(self.data.xmax),
Index: src/sas/sasgui/perspectives/invariant/invariant_panel.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant_panel.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/invariant/invariant_panel.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -240,7 +240,7 @@
         """
 
-        if state == None and data == None:
+        if state is None and data is None:
             self.state = IState()
-        elif state == None or data == None:
+        elif state is None or data is None:
             return
         else:
@@ -604,5 +604,5 @@
         compute invariant
         """
-        if self._data == None:
+        if self._data is None:
             msg = "\n\nData must be loaded first in order"
             msg += " to perform a compution..."
@@ -792,5 +792,5 @@
         : param state_num: the given state number
         """
-        if state_num == None:
+        if state_num is None:
             return
 
@@ -924,5 +924,5 @@
         :param event: rb/cb event
         """
-        if event == None:
+        if event is None:
             return
         obj = event.GetEventObject()
@@ -934,5 +934,5 @@
 
         try:
-            if value == None or value.lstrip().rstrip() == '':
+            if value is None or value.lstrip().rstrip() == '':
                 value = 'None'
             setattr(self.state, name, str(value))
@@ -1013,5 +1013,5 @@
         Used in 'set_current_data()'
         """
-        #if data == None: return
+        #if data is None: return
         #temp_state = self.state.clone_state()
         #copy.deepcopy(self.state.saved_state)
@@ -1049,5 +1049,5 @@
 
         """
-        if self._data == None:
+        if self._data is None:
             return
         # check if this event is from do/undo button
@@ -1072,5 +1072,5 @@
         # try to add new state of the text changes in the state_list
         try:
-            if value.strip() == None:
+            if value.strip() is None:
                 value = ''
             setattr(self.state, name, str(value))
@@ -1140,7 +1140,7 @@
         the popup menu on bookmark context menu event
         """
-        if self._data == None:
+        if self._data is None:
             return
-        if event == None:
+        if event is None:
             return
         self.bookmark_num += 1
@@ -1206,5 +1206,5 @@
         : event: popUpMenu event
         """
-        if event == None:
+        if event is None:
             return
         # get the object
@@ -1246,5 +1246,5 @@
         if self.parent != None:
             self._default_save_location = self.parent.get_save_location()
-        if self._default_save_location == None:
+        if self._default_save_location is None:
             self._default_save_location = os.getcwd()
         dlg = wx.FileDialog(self, "Choose a file",
Index: src/sas/sasgui/perspectives/invariant/invariant_state.py
===================================================================
--- src/sas/sasgui/perspectives/invariant/invariant_state.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/perspectives/invariant/invariant_state.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -787,7 +787,7 @@
             raise RuntimeError, msg
         # make sure title and data run is filled up.
-        if datainfo.title == None or datainfo.title == '':
+        if datainfo.title is None or datainfo.title == '':
             datainfo.title = datainfo.name
-        if datainfo.run_name == None or datainfo.run_name == {}:
+        if datainfo.run_name is None or datainfo.run_name == {}:
             datainfo.run = [str(datainfo.name)]
             datainfo.run_name[0] = datainfo.name
Index: src/sas/sasgui/perspectives/pr/inversion_panel.py
===================================================================
--- src/sas/sasgui/perspectives/pr/inversion_panel.py	(revision c1d5aeab1ee75d2bf50cd73195f34c011918657d)
+++ src/sas/sasgui/perspectives/pr/inversion_panel.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -920,5 +920,5 @@
         if flag:
             dataset = self.plot_data.GetValue()
-            if dataset == None or len(dataset.strip()) == 0:
+            if dataset is None or len(dataset.strip()) == 0:
                 message = "No data to invert. Select a data set before"
                 message += " proceeding with P(r) inversion."
Index: src/sas/sasgui/perspectives/pr/pr.py
===================================================================
--- src/sas/sasgui/perspectives/pr/pr.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/pr/pr.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -291,5 +291,5 @@
         """
         qtemp = pr.x
-        if not q == None:
+        if not q is None:
             qtemp = q
 
@@ -303,7 +303,7 @@
 
         # Check for user min/max
-        if not pr.q_min == None:
+        if not pr.q_min is None:
             minq = pr.q_min
-        if not pr.q_max == None:
+        if not pr.q_max is None:
             maxq = pr.q_max
 
@@ -393,5 +393,5 @@
 
         for i in range(len(x)):
-            if cov2 == None:
+            if cov2 is None:
                 value = pr.pr(out, x[i])
             else:
@@ -412,5 +412,5 @@
             dy = dy / pmax
 
-        if cov2 == None:
+        if cov2 is None:
             new_plot = Data1D(x, y)
             new_plot.symbol = GUIFRAME_ID.CURVE_SYMBOL_NUM
@@ -487,5 +487,5 @@
         scale = None
         min_err = 0.0
-        if not path == None:
+        if not path is None:
             input_f = open(path, 'r')
             buff = input_f.read()
@@ -499,5 +499,5 @@
                         err = float(toks[2])
                     else:
-                        if scale == None:
+                        if scale is None:
                             scale = 0.05 * math.sqrt(y)
                             #scale = 0.05/math.sqrt(y)
@@ -512,5 +512,5 @@
                     logger.error(sys.exc_value)
 
-        if not scale == None:
+        if not scale is None:
             message = "The loaded file had no error bars, statistical errors are assumed."
             wx.PostEvent(self.parent, StatusEvent(status=message))
@@ -537,5 +537,5 @@
 
         data_started = False
-        if not path == None:
+        if not path is None:
             input_f = open(path, 'r')
             buff = input_f.read()
@@ -550,5 +550,5 @@
                             err = float(toks[2])
                         else:
-                            if scale == None:
+                            if scale is None:
                                 scale = 0.05 * math.sqrt(y)
                                 #scale = 0.05/math.sqrt(y)
@@ -565,5 +565,5 @@
                     data_started = True
 
-        if not scale == None:
+        if not scale is None:
             message = "The loaded file had no error bars, statistical errors are assumed."
             wx.PostEvent(self.parent, StatusEvent(status=message))
@@ -761,5 +761,5 @@
         self.elapsed = elapsed
         self.control_panel.alpha_estimate = alpha
-        if not message == None:
+        if not message is None:
             wx.PostEvent(self.parent, StatusEvent(status=str(message)))
         self.perform_estimateNT()
@@ -779,5 +779,5 @@
         self.control_panel.nterms_estimate = nterms
         self.control_panel.alpha_estimate = alpha
-        if not message == None:
+        if not message is None:
             wx.PostEvent(self.parent, StatusEvent(status=str(message)))
 
@@ -858,5 +858,5 @@
 
         # Make a plot of I(q) data
-        if self.pr.err == None:
+        if self.pr.err is None:
             new_plot = Data1D(self.pr.x, self.pr.y)
             new_plot.symbol = GUIFRAME_ID.CURVE_SYMBOL_NUM
@@ -921,5 +921,5 @@
         try:
             pr = self._create_plot_pr()
-            if not pr == None:
+            if not pr is None:
                 self.pr = pr
                 self.perform_inversion()
@@ -944,5 +944,5 @@
         try:
             pr = self._create_plot_pr()
-            if not pr == None:
+            if not pr is None:
                 self.pr = pr
                 self.perform_estimate()
@@ -983,5 +983,5 @@
         err = self.current_plottable.dy
         all_zeros = True
-        if err == None:
+        if err is None:
             err = np.zeros(len(pr.y))
         else:
@@ -995,5 +995,5 @@
             for i in range(len(pr.y)):
                 # Scale the error so that we can fit over several decades of Q
-                if scale == None:
+                if scale is None:
                     scale = 0.05 * math.sqrt(pr.y[i])
                     min_err = 0.01 * pr.y[i]
@@ -1024,5 +1024,5 @@
         try:
             pr = self._create_file_pr(data)
-            if not pr == None:
+            if not pr is None:
                 self.pr = pr
                 self.perform_inversion()
@@ -1090,5 +1090,5 @@
         # If we have not errors, add statistical errors
         if y is not None:
-            if err == None or np.all(err) == 0:
+            if err is None or np.all(err) == 0:
                 err = np.zeros(len(y))
                 scale = None
@@ -1096,5 +1096,5 @@
                 for i in range(len(y)):
                     # Scale the error so that we can fit over several decades of Q
-                    if scale == None:
+                    if scale is None:
                         scale = 0.05 * math.sqrt(y[i])
                         min_err = 0.01 * y[i]
Index: src/sas/sasgui/perspectives/pr/pr_thread.py
===================================================================
--- src/sas/sasgui/perspectives/pr/pr_thread.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/perspectives/pr/pr_thread.py	(revision 235f514ba93b57fa63e44309f182acef0b98bb55)
@@ -42,5 +42,5 @@
             pass
         except:
-            if not self.error_func == None:
+            if not self.error_func is None:
                 self.error_func("CalcPr.compute: %s" % sys.exc_value)
 
@@ -70,5 +70,5 @@
             pass
         except:
-            if not self.error_func == None:
+            if not self.error_func is None:
                 self.error_func("EstimatePr.compute: %s" % sys.exc_value)
 
@@ -110,4 +110,4 @@
             pass
         except:
-            if not self.error_func == None:
+            if not self.error_func is None:
                 self.error_func("EstimatePr2.compute: %s" % sys.exc_value)