Index: src/sas/guiframe/local_perspectives/data_loader/data_loader.py
===================================================================
--- src/sas/guiframe/local_perspectives/data_loader/data_loader.py	(revision 8729965813fed53bbb14373a2965fcad9856c62d)
+++ src/sas/guiframe/local_perspectives/data_loader/data_loader.py	(revision b9dbd6b5e3f5275da6eb798e3bc7343fddcb6d50)
@@ -9,11 +9,6 @@
 
 from sas.dataloader.loader import Loader
-import sas.dataloader.data_info as DataInfo
 from sas.guiframe.plugin_base import PluginBase
 from sas.guiframe.events import StatusEvent
-from sas.guiframe.events import NewPlotEvent
-from sas.guiframe.dataFitting import Data1D
-from sas.guiframe.dataFitting import Data2D
-from sas.guiframe.utils import parse_name
 from sas.guiframe.gui_style import GUIFRAME
 from sas.guiframe.gui_manager import DEFAULT_OPEN_FOLDER
@@ -25,50 +20,32 @@
         (os.path.isfile("%s/%s.pyc" % (path, 'local_config'))):
         fObj, path, descr = imp.find_module('local_config', [path])
-        config = imp.load_module('local_config', fObj, path, descr)  
+        config = imp.load_module('local_config', fObj, path, descr)
     else:
         # Try simply importing local_config
         import local_config as config
 except:
-    # Didn't find local config, load the default 
+    # Didn't find local config, load the default
     import sas.guiframe.config as config
 
 if config is None:
     import sas.guiframe.config as config
-    
-       
+
+
 extension_list = []
 if config.APPLICATION_STATE_EXTENSION is not None:
     extension_list.append(config.APPLICATION_STATE_EXTENSION)
-EXTENSIONS = config.PLUGIN_STATE_EXTENSIONS + extension_list   
+EXTENSIONS = config.PLUGIN_STATE_EXTENSIONS + extension_list
 PLUGINS_WLIST = config.PLUGINS_WLIST
 APPLICATION_WLIST = config.APPLICATION_WLIST
 
 class Plugin(PluginBase):
-    
+
     def __init__(self, standalone=False):
         PluginBase.__init__(self, name="DataLoader", standalone=standalone)
-        #Default location
+        # Default location
         self._default_save_location = DEFAULT_OPEN_FOLDER
-        self.loader = Loader()  
-        self._data_menu = None 
-        
-    def help(self, evt):
-        """
-        Show a general help dialog. 
-        """
-#        from documentation_window import DocumentationWindow     
-#        _sphinx_doc_viewer = DocumentationWindow(self, -1, "/user/guiframe/ \
-#            data_explorer_help.html", "DataLoader Help")
-#        from help_panel import  HelpWindow
-#        frame = HelpWindow(None, -1) 
-#        if hasattr(frame, "IsIconized"):
-#            if not frame.IsIconized():
-#                try:
-#                    icon = self.parent.GetIcon()
-#                    frame.SetIcon(icon)
-#                except:
-#                    pass  
-#        frame.Show(True)
-        
+        self.loader = Loader()
+        self._data_menu = None
+
     def populate_file_menu(self):
         """
@@ -76,5 +53,5 @@
         add load file menu item and load folder item
         """
-        #menu for data files
+        # menu for data files
         menu_list = []
         data_file_hint = "load one or more data in the application"
@@ -84,10 +61,9 @@
         style1 = gui_style & GUIFRAME.DATALOADER_ON
         if style == GUIFRAME.MULTIPLE_APPLICATIONS:
-            #menu for data from folder
+            # menu for data from folder
             data_folder_hint = "load multiple data in the application"
-            menu_list.append(('&Load Data Folder', data_folder_hint, 
+            menu_list.append(('&Load Data Folder', data_folder_hint,
                               self._load_folder))
         return menu_list
-   
 
     def load_data(self, event):
@@ -99,5 +75,5 @@
         if self._default_save_location == None:
             self._default_save_location = os.getcwd()
-        
+
         cards = self.loader.get_wildcards()
         temp = [APPLICATION_WLIST] + PLUGINS_WLIST
@@ -105,24 +81,24 @@
             if item in cards:
                 cards.remove(item)
-        wlist =  '|'.join(cards)
-        style = wx.OPEN|wx.FD_MULTIPLE
-        dlg = wx.FileDialog(self.parent, 
-                            "Choose a file", 
+        wlist = '|'.join(cards)
+        style = wx.OPEN | wx.FD_MULTIPLE
+        dlg = wx.FileDialog(self.parent,
+                            "Choose a file",
                             self._default_save_location, "",
-                             wlist,
-                             style=style)
+                            wlist,
+                            style=style)
         if dlg.ShowModal() == wx.ID_OK:
             file_list = dlg.GetPaths()
-            if len(file_list) >= 0 and not(file_list[0]is None):
+            if len(file_list) >= 0 and not file_list[0] is None:
                 self._default_save_location = os.path.dirname(file_list[0])
                 path = self._default_save_location
         dlg.Destroy()
-        
+
         if path is None or not file_list or file_list[0] is None:
             return
         self.parent._default_save_location = self._default_save_location
         self.get_data(file_list)
-        
-        
+
+
     def can_load_data(self):
         """
@@ -130,6 +106,6 @@
         """
         return True
- 
-       
+
+
     def _load_folder(self, event):
         """
@@ -140,7 +116,7 @@
         if self._default_save_location == None:
             self._default_save_location = os.getcwd()
-        dlg = wx.DirDialog(self.parent, "Choose a directory", 
+        dlg = wx.DirDialog(self.parent, "Choose a directory",
                            self._default_save_location,
-                            style=wx.DD_DEFAULT_STYLE)
+                           style=wx.DD_DEFAULT_STYLE)
         if dlg.ShowModal() == wx.ID_OK:
             path = dlg.GetPath()
@@ -150,20 +126,20 @@
             self._default_save_location = os.path.dirname(path)
         else:
-            return    
+            return
         file_list = self.get_file_path(path)
         self.get_data(file_list)
         self.parent._default_save_location = self._default_save_location
-        
+
     def load_error(self, error=None):
         """
         Pop up an error message.
-        
+
         :param error: details error message to be displayed
         """
         if error is not None or str(error).strip() != "":
             dial = wx.MessageDialog(self.parent, str(error), 'Error Loading File',
-                                wx.OK | wx.ICON_EXCLAMATION)
-            dial.ShowModal()  
-        
+                                    wx.OK | wx.ICON_EXCLAMATION)
+            dial.ShowModal()
+
     def get_file_path(self, path):
         """
@@ -171,7 +147,6 @@
         """
         if os.path.isdir(path):
-            return [os.path.join(os.path.abspath(path),
-                                  file) for file in os.listdir(path)]
-   
+            return [os.path.join(os.path.abspath(path), filename) for filename in os.listdir(path)]
+
     def _process_data_and_errors(self, item, p_file, output, message):
         """
@@ -186,5 +161,5 @@
         output[data.id] = data
         return output, message, data_error
-   
+
     def get_data(self, path, format=None):
         """
@@ -198,5 +173,5 @@
         for p_file in path:
             info = "info"
-            basename  = os.path.basename(p_file)
+            basename = os.path.basename(p_file)
             _, extension = os.path.splitext(basename)
             if extension.lower() in EXTENSIONS:
@@ -209,21 +184,21 @@
                 logging.info(log_msg)
                 continue
-        
+
             try:
                 message = "Loading Data... " + str(p_file) + "\n"
                 self.load_update(output=output, message=message, info=info)
-                temp =  self.loader.load(p_file, format)
+                temp = self.loader.load(p_file, format)
                 if temp.__class__.__name__ == "list":
                     for item in temp:
                         output, error_message, data_error = \
-                            self._process_data_and_errors(item, 
-                                                          p_file, 
-                                                          output, 
+                            self._process_data_and_errors(item,
+                                                          p_file,
+                                                          output,
                                                           error_message)
                 else:
                     output, error_message, data_error = \
-                            self._process_data_and_errors(temp, 
-                                                          p_file, 
-                                                          output, 
+                            self._process_data_and_errors(temp,
+                                                          p_file,
+                                                          output,
                                                           error_message)
             except:
@@ -243,15 +218,14 @@
                 error_message = base_message + error_message
             else:
-                error_message += "%s\n"% str(p_file)
+                error_message += "%s\n" % str(p_file)
             info = "error"
-            self.load_update(output=output, message=error_message, 
-                                  info=info)
-                
+            self.load_update(output=output, message=error_message, info=info)
+
         else:
             message = "Loading Data Complete! "
         message += log_msg
         self.load_complete(output=output, error_message=error_message,
-                       message=message, path=path, info=info)
-            
+                           message=message, path=path, info=info)
+
     def load_update(self, output=None, message="", info="warning"):
         """
@@ -259,19 +233,18 @@
         """
         if message != "":
-            wx.PostEvent(self.parent, StatusEvent(status=message, info='info', 
+            wx.PostEvent(self.parent, StatusEvent(status=message, info='info',
                                                   type="progress"))
-    def load_complete(self, output, message="", error_message="", path=None, 
+    def load_complete(self, output, message="", error_message="", path=None,
                       info="warning"):
         """
          post message to  status bar and return list of data
         """
-        wx.PostEvent(self.parent, StatusEvent(status=message, 
+        wx.PostEvent(self.parent, StatusEvent(status=message,
                                               info=info,
                                               type="stop"))
-        #if error_message != "":
+        # if error_message != "":
         #    self.load_error(error_message)
         self.parent.add_data(data_list=output)
-   
-    
-        
-   
+
+
+
Index: src/sas/guiframe/local_perspectives/data_loader/help_panel.py
===================================================================
--- src/sas/guiframe/local_perspectives/data_loader/help_panel.py	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ 	(revision )
@@ -1,106 +1,0 @@
-#!/usr/bin/python
-"""
-Help panel for data_loader plugins
-"""
-import os
-import wx
-import wx.html as html
-from wx.lib.splitter import MultiSplitterWindow
-from sas.guiframe import get_media_path
-
-class HelpWindow(wx.Frame):
-    """
-    """
-    def __init__(self, parent, title='DataLoader Help', pageToOpen=None):
-        wx.Frame.__init__(self, parent, title, size=(700, 450))
-        """
-             contains help info
-        """
-        self.SetTitle('DataLoader Help') 
-        splitter = MultiSplitterWindow(self, style=wx.SP_LIVE_UPDATE)
-        rpanel = wx.Panel(splitter, -1)
-        lpanel = wx.Panel(splitter, -1, style=wx.BORDER_SUNKEN)
-        
-        vbox = wx.BoxSizer(wx.VERTICAL)
-        header = wx.Panel(rpanel, -1)
-        header.SetBackgroundColour('#6666FF')
-        header.SetForegroundColour('WHITE')
-        hbox = wx.BoxSizer(wx.HORIZONTAL)
-        st = wx.StaticText(header, -1, 'Contents', (5, 5))
-        font = st.GetFont()
-        font.SetPointSize(10)
-        st.SetFont(font)
-        hbox.Add(st, 1, wx.TOP | wx.BOTTOM | wx.LEFT, 5)
-        header.SetSizer(hbox)
-        vbox.Add(header, 0, wx.EXPAND)
-       
-        vboxl = wx.BoxSizer(wx.VERTICAL)
-        headerl = wx.Panel(lpanel, -1, size=(-1, 20))
-       
-        headerl.SetBackgroundColour('#6666FF')
-        headerl.SetForegroundColour('WHITE')
-        hboxl = wx.BoxSizer(wx.HORIZONTAL)
-        lst = wx.StaticText(headerl, -1, 'Menu', (5, 5))
-        fontl = lst.GetFont()
-        fontl.SetPointSize(10)
-        lst.SetFont(fontl)
-        hboxl.Add(lst, 1, wx.TOP | wx.BOTTOM | wx.LEFT, 5)
-        headerl.SetSizer(hboxl)
-        vboxl.Add(headerl, 0, wx.EXPAND)
-        self.lhelp = html.HtmlWindow(lpanel, -1, style=wx.NO_BORDER)
-        self.rhelp = html.HtmlWindow(rpanel, -1, style=wx.NO_BORDER, 
-                                     size=(500,-1))
-        
-        self.path = get_media_path(media='media')
-        page1 = """<html>
-            <body>
-             <p>Select topic on Menu</p>
-            </body>
-            </html>"""
-        self.rhelp.SetPage(page1)
-        page = """<html>
-            <body>
-            <ul>
-            <li><a href ="data_explorer_help.html" 
-            target ="showframe">Data Explorer</a><br></li>
-            </ul>
-            </body>
-            </html>"""
-
-        self.lhelp.SetPage(page)
-        self.lhelp.Bind(wx.html.EVT_HTML_LINK_CLICKED, self.OnLinkClicked)
-        
-        vbox.Add(self.rhelp, 1, wx.EXPAND)
-        vboxl.Add(self.lhelp, 1, wx.EXPAND)
-        rpanel.SetSizer(vbox)
-        lpanel.SetSizer(vboxl)
-        lpanel.SetFocus()
-        
-        vbox1 = wx.BoxSizer(wx.HORIZONTAL)
-        vbox1.Add(splitter, 1, wx.EXPAND)
-        splitter.AppendWindow(lpanel, 200)
-        splitter.AppendWindow(rpanel)
-        self.SetSizer(vbox1)
-       
-        self.Centre()
-        self.Show(True)
-        
-    def OnLinkClicked(self, event):
-        """
-            Function to diplay html page related to the hyperlinktext selected
-        """
-        link = event.GetLinkInfo().GetHref()
-        link = os.path.join(self.path, link)
-        self.rhelp.LoadPage(link)
-        
-        
-class ViewApp(wx.App):
-    def OnInit(self):
-        frame = HelpWindow(None, -1, 'HelpWindow')    
-        frame.Show(True)
-        self.SetTopWindow(frame)
-        return True
-        
-if __name__ == "__main__": 
-    app = ViewApp(0)
-    app.MainLoop()     
Index: src/sas/guiframe/local_perspectives/data_loader/load_thread.py
===================================================================
--- src/sas/guiframe/local_perspectives/data_loader/load_thread.py	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ src/sas/guiframe/local_perspectives/data_loader/load_thread.py	(revision b9dbd6b5e3f5275da6eb798e3bc7343fddcb6d50)
@@ -1,3 +1,5 @@
-
+"""
+    Loading thread
+"""
 import time
 import sys
@@ -6,5 +8,5 @@
 from sas.data_util.calcthread import CalcThread
 
-        
+
 EXTENSIONS = ['.svs', '.prv', '.inv', '.fitv']
 
@@ -17,21 +19,20 @@
                  transform_data=None,
                  completefn=None,
-                 updatefn   = None,
-                 yieldtime  = 0.01,
-                 worktime   = 0.01
-                 ):
+                 updatefn=None,
+                 yieldtime=0.01,
+                 worktime=0.01):
         CalcThread.__init__(self, completefn,
-                 updatefn,
-                 yieldtime,
-                 worktime)
+                            updatefn,
+                            yieldtime,
+                            worktime)
         self.load_state_flag = flag
         self.transform_data = transform_data
         self.list_path = path
-        #Instantiate a loader 
+        # Instantiate a loader
         self.loader = loader
         self.message = ""
-        self.starttime = 0  
+        self.starttime = 0
         self.updatefn = updatefn
-        
+
     def isquit(self):
         """
@@ -41,7 +42,6 @@
             CalcThread.isquit(self)
         except KeyboardInterrupt:
-            raise KeyboardInterrupt   
-        
-        
+            raise KeyboardInterrupt
+
     def compute(self):
         """
@@ -52,6 +52,6 @@
         error_message = ""
         for path in self.list_path:
-            basename  = os.path.basename(path)
-            root, extension = os.path.splitext(basename)
+            basename = os.path.basename(path)
+            _, extension = os.path.splitext(basename)
             if self.load_state_flag:
                 if extension.lower() in EXTENSIONS:
@@ -61,6 +61,5 @@
                     pass
             try:
-                temp =  self.loader.load(path)
-                elapsed = time.time() - self.starttime
+                temp = self.loader.load(path)
                 if temp.__class__.__name__ == "list":
                     for item in temp:
@@ -77,9 +76,6 @@
                 error_message += str(sys.exc_value) + "\n"
                 self.updatefn(output=output, message=error_message)
-                
+
         message = "Loading Complete!"
         self.complete(output=output, error_message=error_message,
-                       message=message, path=self.list_path)
-            
-   
-      
+                      message=message, path=self.list_path)