Index: sasview/README.txt
===================================================================
--- sasview/README.txt	(revision 9a182b24778d8ca30e8e54968548156199dd1240)
+++ sasview/README.txt	(revision 243fbc08b5507d76300536ef5949cadf6da173c0)
@@ -4,51 +4,4 @@
 1- Features
 ===========
-    - New in Version 4.0
-      ------------------
-      This release fixes the various bugs found during the alpha and beta testing
-      - Improvements
-        - Support for reading data files from Anton Paar Saxess instruments
-        - Adds documentation on how to write custom models in the new framework
-      - Bug Fixes
-        - Fixes bug #604 Pringle model questions
-        - Fixes bug #472 Reparameterize Teubner-Strey
-        - Fixes bug #530 Numerical instabilities in Teubner Strey model
-        - Fixes bug #658 ASCII reader very broken
-
-
-    - New in Version 4.0 beta 1
-      --------------------
-      This beta adds support for the magnetic and multilevel models of 3.1.2
-      and along with a host of bug fixes found in the alpha.
-
-      - Model package changes and improvements
-         - All 3.1.2 models now available in new interface
-         - Old custom models should now still work
-            - '''NOTE:''' These will be deprecated in a future version. Old
-            custom models should be converted to the new model format which
-            is now the same as the built in models and offers much better
-            support.
-         - Custom model editor now creates new style models
-         - Custom model editor supports better error checking
-      - Documentation improvements
-        - Continued general cleanup
-      - Other improvements/additions
-         - Support for new canSAS 2D data files added
-         - Plot axes range can now be set manually as well as by zooming
-         - Plot annotations can now be moved around after being placed on plot.
-         - The active optimizer is now listed on the top of the fit panel.
-         - Linear fits now update qmin and max when the x scale limits are
-         changed.  Also the plot range no longer resets after a fit.
-      - Bug fixes
-         - Fixes bug #511 Errors in linearized fits and clean up of interface
-         including Kratky representation
-         - Fixes bug #186 Data operation Tool now executes when something is
-         entered in the text box and does not wait for the user to hit enter
-         - Fixes bug #459 plot context menu bug
-         - Fixes bug #559 copy to clipboard in graph menu broken
-         - Fixes bug #466 cannot remove a linear fit from graph
-         - Numerous bugs introduced in the alpha
-
-
 
     - New in Version 4.0.0-alpha
@@ -91,12 +44,12 @@
    - New in Version 3.1.2
      --------------------
-     This release is a major stability improvement, having fixed a serious bug
+     This release is a major stability improvement, having fixed a serious bug 
      that came to light since release 3.1.1. All users should upgrade.
 
-     - Fixes bug #468 broken remove constraint buttons in
+     - Fixes bug #468 broken remove constraint buttons in 
        simultaneous/constrained fitting panel
-     - Fixes bug #474 resulting from changes in 3.1.1 that had
+     - Fixes bug #474 resulting from changes in 3.1.1 that had 
        introduced an error in the high-Q of slit-smeared models.
-     - Fixes bug #478 which would cause wx to run out of IDs and result
+     - Fixes bug #478 which would cause wx to run out of IDs and result 
        in SasView crashing even if left alone.
      - Fixes bug #479 missing help button on simultaneous/constrained fit page
@@ -122,7 +75,7 @@
          documentation.
        - The model help has been split so that the Details button now brings up
-         a very short pop-up giving the equation being used while HELP goes to
+         a very short pop-up giving the equation being used while HELP goes to 
          the section in the full documentation describing the model.
-       - Extensive help has also been added for the new optimizer engine (see
+       - Extensive help has also been added for the new optimizer engine (see 
          below) including rules of thumb on how and when to choose a given
          optimizer and what the parameters do.
@@ -139,5 +92,5 @@
          - A Nelder-Mead Simplex optimizer
          - A Differential Evolution optimizer
-         - A Monte Carlo optimizer (DREAM)
+         - A Monte Carlo optimizer (DREAM) 
      - New models were added:
          - MicelleSphCoreModel (currently residing in the Uncategorized category)
@@ -148,5 +101,5 @@
          - RectangularHollowPrismInfThinWallsModel
      - Infrastructure to allow SESANS data to be fit with models was added. This
-       will become available in a future release but can currently be used from
+       will become available in a future release but can currently be used from 
        the command line with some caveats.
      - A number of bugs were fixed including a thread crashing issue and an
@@ -173,26 +126,26 @@
        floating.
      - Five new models have been added: PringlesModel, CoreShellEllipsoidXTModel,
-       RectangularPrismModel, RectangularHollowPrismModel and
+       RectangularPrismModel, RectangularHollowPrismModel and 
        RectangularHollowPrismInfThinWallsModel.
-     - The data loader now supports ILL DAT data files and reads the full meta
+     - The data loader now supports ILL DAT data files and reads the full meta 
        information from canSAS file formats.
      - Redefined convention for specifying angular parameters for anisotropic
        models.
-     - A number of minor features have been added such as permitting a log
-       distribution of points when using a model to simulate data, and the
+     - A number of minor features have been added such as permitting a log 
+       distribution of points when using a model to simulate data, and the 
        addition of a Kratky plot option to the linear plots.
      - A number of bugs have also been fixed.
      - Save Project and Save Analysis now work more reliably.
-     - BETA: Magnetic contrast supporting full polarization analysis has been
+     - BETA: Magnetic contrast supporting full polarization analysis has been 
        implemented for some spherical and cylindrical models.
      - BETA: Two new tools have been added:
-       - A generic scattering calculator which takes an atomic, magnetic or
-         SLD distribution in space and generates the appropriate 2D
-         scattering pattern. In some cases the orientationally averaged
-         (powder) 1D scattering can also be computed. Supported formats
-         include: SLD or text, PDB, and OMF magnetic moment distribution
+       - A generic scattering calculator which takes an atomic, magnetic or 
+         SLD distribution in space and generates the appropriate 2D 
+         scattering pattern. In some cases the orientationally averaged 
+         (powder) 1D scattering can also be computed. Supported formats 
+         include: SLD or text, PDB, and OMF magnetic moment distribution 
          file.
-       - An image viewer/converter for data in image format; this reads in
-         an image file and will attempt to convert the image pixels to
+       - An image viewer/converter for data in image format; this reads in 
+         an image file and will attempt to convert the image pixels to 
          data. Supported formats include: TIFF, TIF, PNG, BMP, JPG.
 
@@ -222,9 +175,9 @@
      - Added more plot symbols options for 1d plots
      - Added improved trapping of compiling errors to the 'New model editor'
-     - Added some intelligent outputs (e.g., Rg, background, or rod diameter
+     - Added some intelligent outputs (e.g., Rg, background, or rod diameter 
        depending on the choice of axis scale of the plot) to the linear fits
      - Added more models
-
-   - Feature set from previous versions
+     
+   - Feature set from previous versions 	
      -----------------------------------
      - Perspectives Available
@@ -232,10 +185,10 @@
          specific surface area.
        - P(r) inversion calculator: Indirect Fourier transformation method.
-       - Fitting: the tool used for modeling and fitting 1D and 2D data to
+       - Fitting: the tool used for modeling and fitting 1D and 2D data to 
          analytical model functions
        - Tools: provides a number of useful supplementary tools such as SLD
-         calculation
-
-     - Fitting
+         calculation  
+    
+     - Fitting 
        - Includes a large number of model functions, both form factors and structure factors.
        - Support P(Q)*S(Q) for form factors that flag they can be so multiplied.
@@ -245,8 +198,8 @@
        - Anisotropic shapes and magnetic moment modeling in 2D allow for a non-uniform
          distribution of orientations of a given axis leading to modeling and fitting
-         capabilities of non azimuthaly symmetric data.
+         capabilities of non azimuthaly symmetric data.  
        - User can choose to weight fits or not. If using weights, the user can choose
          the error bar on each point if provided in the file, the square root
-         of the intensity or the intensity itself.
+         of the intensity or the intensity itself. 
        - Instrumental resolution smearing of model or fits is provided with several
          options: read the resolution/point fromt he file. Input a pinhole resolution
@@ -261,6 +214,6 @@
          data set or several different sets simultaneously with the application
          of advanced constraints relating fit parameters to functions of other
-         parameters (including from a different set). For example thickness of
-         shell = sin(30) times the length.
+         parameters (including from a different set). For example thickness of 
+         shell = sin(30) times the length.  
        - Models that are the sum of two other models can be easily generated through the
          SUM Model menubar item.
@@ -271,11 +224,11 @@
          and the mathematical function of the model (box 2) and generating the
          necessary *.py file.  A separate advanced model editor provides a full Python
-         file editor.  Either way once saved the model becomes immediately available
-         to the application.
+         file editor.  Either way once saved the model becomes immediately available 
+         to the application. 
        - A batch fitting capability allows for the analysis of a series of data sets to
          a single model and provides the results in a tabular form suitable for saving
          or plotting the evolution of the fit parameters with error bars (from within
          the application).
-
+ 
      - Tools
        - A scattering length density calculator,including some X-ray information
@@ -287,5 +240,5 @@
        - A slit size calculator optimized for Anton Paar Saxess is provided.
        - A kiessig fringe thickness calculator is provided
-
+         
      - Plots and plot management
        - A 3D graphing option (for 2d data/results) is provided with the view
@@ -301,8 +254,8 @@
        - Extensive context sensitive plot/fitting/manipulation options are available
          through a right mouse click pop-up menu on plots.
-
+           
      - Data management
        - Supports 2 + column 1D ASCII data, NIST 1D and 2D data, and canSAS data
-         via plug-in mechanism which can easily allow other readers as appropriate.
+         via plug-in mechanism which can easily allow other readers as appropriate. 
        - 2D data is expected in Q space but for historical reasons accepts the
          NIST 2D raw pixel format and will do conversion internally.
@@ -310,5 +263,5 @@
          right clicking on a data set and choosing Data Info in the DataExplorer
          or on the plots
-       - Supports loading a single file, multiple files, or a whole folder
+       - Supports loading a single file, multiple files, or a whole folder   
        - An optional Data Explorer is provided (default) which simplifies managing,
          plotting, deleting, or setup for computation. Most functions however do
@@ -316,5 +269,5 @@
          right click menus and the toolbar.  The data explorer can be re-started
          from the menu bar.
-
+           
      - Data manipulation
        - Support various 2D averaging methods : Circular, sectors, annular,
@@ -322,5 +275,5 @@
        - A 2D data maks editor is provided
        - 2D mask can be applied to the circular averaging.
-
+         
      - Miscellaneous features
        - limited reports can be generated in pdf format
@@ -343,5 +296,5 @@
 2- Downloading and Installing
 =============================
-
+	
    *** Note 1:  Much more information is available at www.sasview.org under links.
 	            Look in the 'For Developers' section and particularly the wiki at
@@ -382,5 +335,5 @@
         - The following modules are required (version numbers are what are used
           in the windows release build):
-
+          
           - Common Packages
             - reportlab 3.1.44
@@ -399,5 +352,5 @@
             - html5lib Version Installed: 0.99999
             - wx Version Installed: 3.0.2.0
-
+          
           - Windows Specific Packages
             - pywin 219
@@ -405,5 +358,5 @@
             - comtypes 1.1.1
             - MinGW w/ gcc version 4.6.1 (WIN)
-            - vcredist_x86.exe (version 9.0.21022.8  -microsoft visual C 2008
+            - vcredist_x86.exe (version 9.0.21022.8  -microsoft visual C 2008 
               re-distributable)
             - Innosetup (WIN - isetup 5.4.2-unicode) - used to create distributable
@@ -411,8 +364,8 @@
             *** Note: Windows build dependencies can be set up using anaconda. Instructions
                 can be found at http://trac.sasview.org/wiki/AnacondaSetup
-
+            
           - MAC Specifc Packages
             - py2app 0.7.1
-
+          
 
 3- Known Issues
@@ -424,14 +377,14 @@
           equations will render properly. Until then they will show in their
           original TeX format.
-        - If the documentation window remains stubbornly blank, try installing a
+        - If the documentation window remains stubbornly blank, try installing a 
           different browser and set that as your default browser. Issues have
           been noted with Internet Explorer 11.
-        - Check for Updates may fail (with the status bar message ' Cannot
-          connect to the application server') if your internet connection uses
-          a proxy server. Tested resolutions for this are described on the
+        - Check for Updates may fail (with the status bar message ' Cannot 
+          connect to the application server') if your internet connection uses 
+          a proxy server. Tested resolutions for this are described on the 
           website FAQ.
         - The copy and paste functions (^C, ^V) in the batch mode results grid
           require two clicks: one to select the cell and a second to select the
-          contents of the cell.
+          contents of the cell. 
         - The tutorial has not yet been updated and is somewhat out of date
         - Very old computers may struggle to run the 3.x and later releases
@@ -448,5 +401,5 @@
         - The angular distribution angles are not clearly defined and may in
           some cases lead to incorrect calculations(ticket #332)
-
+          
    3.2- Windows:
         - If installed to same directory as old version without first removing
@@ -455,10 +408,10 @@
           have the old name even though pointing to the new version.  Usually
           safest to uninstall old version prior to installing new version anyway.
-
+		
    3.3- MAC:
         - Application normally starts up hidden. Click icon in Dock to view/use
-          application.
+          application. 
         - Multiprocessing does not currently work on MAC OS
-
+		
    3.4- Linux:
         - Not well tested
@@ -468,5 +421,5 @@
 ==================
 
-   - www.sasview.org.  This main project site is the gateway to all
+   - www.sasview.org.  This main project site is the gateway to all 
      information about the sasview project.  It includes information
      about the project, a FAQ page and links to all developer and user
@@ -487,2 +440,4 @@
    - Latest developer builds
      - https://jenkins.esss.dk/sasview/view/Master-Builds/
+
+    